import { CompletionContext, CompletionResult } from '@codemirror/autocomplete';
import { EditorState } from '@codemirror/state';
import { SyntaxNode } from '@lezer/common';
export declare const matcherTerms: {
    label: string;
}[];
export declare const operatorTerms: {
    label: string;
}[];
export declare enum ContextKind {
    KeyPath = 0,
    Pattern = 1,
    QueryMatcher = 2,
    QueryOperator = 3
}
interface TreeTerms {
    terms: (string | RegExp)[];
    depth: number;
}
export interface Context {
    kind: ContextKind;
    treeTerms: TreeTerms;
}
export declare function analyzeCompletion(state: EditorState, node: SyntaxNode, pos: number): Context[];
export declare class Complete {
    private readonly tree?;
    private readonly objectList?;
    constructor(objects?: Record<string, unknown>[]);
    kvSearch(context: CompletionContext): CompletionResult | null;
    private autocompleteQueryPath;
    private autocompleteQueryPattern;
}
export {};
